ProductSubscribeReadonlyProperties:
  type: object
  properties:
    id:
      type: integer
      description: Идентификатор
      example: 1
ProductSubscribeFillableProperties:
  type: object
  properties:
    product_id:
      type: integer
      description: Идентификатор товара
      example: 104
    customer_id:
      type: integer
      description: Идентификатор клиента
      example: 11
ProductSubscribeRequiredProperties:
  type: object
  required:
    - product_id
    - customer_id

ProductSubscribeForCreate:
  allOf:
    - $ref: '#/ProductSubscribeFillableProperties'
    - $ref: '#/ProductSubscribeRequiredProperties'
ProductSubscribe:
  allOf:
    - $ref: '#/ProductSubscribeReadonlyProperties'
    - $ref: '#/ProductSubscribeFillableProperties'

SearchProductSubscribesFilter:
  type: object
  properties:
    id:
      type: integer
      description: Идентификатор записи
      example: 11
      nullable: true
    customer_id:
      type: integer
      description: Идентификатор клиента
      example: 2
      nullable: true
    product_id:
      type: integer
      description: Идентификатор товара
      example: 2
      nullable: true

SearchProductSubscribesRequest:
  type: object
  properties:
    sort:
      $ref: '../../common_schemas.yaml#/RequestBodySort'
    filter:
      $ref: '#/SearchProductSubscribesFilter'
    include:
      $ref: '../../common_schemas.yaml#/RequestBodyInclude'
    pagination:
      $ref: '../../common_schemas.yaml#/RequestBodyPagination'

DeleteProductSubscribesRequest:
  type: object
  properties:
    product_id:
      type: integer
      description: Идентификатор товара
      example: 104
    customer_id:
      type: integer
      description: Идентификатор клиента
      example: 11

ClearProductSubscribesRequest:
  type: object
  properties:
    customer_id:
      type: integer
      description: Идентификатор клиента
      example: 11

ProductSubscribeResponse:
  type: object
  properties:
    data:
      $ref: '#/ProductSubscribe'
    meta:
      type: object
  required:
    - data

SearchProductSubscribesResponse:
  type: object
  properties:
    data:
      type: array
      items:
        $ref: '#/ProductSubscribe'
    meta:
      type: object
      properties:
        pagination:
          $ref: '../../common_schemas.yaml#/ResponseBodyPagination'
  required:
    - data
    - meta
